//+------------------------------------------------------------------+
//|                      Original  framework from Clock.mq4, Jerome. |
//|                                       Alll Other work by Husky_1 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Husky"

//    corner    - 0 = top left, 1 = top right, 2 = bottom left, 3 = bottom right
//    topOff    - pixels from top to show the clock
//    indicator_color1 - Color of label
//    clockColor- Color of clock

//
//#property indicator_chart_window
#property  indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LightBlue  //Label color
#property indicator_color2 LightBlue // Value Color

//---- input parameters

extern int          corner=0;
extern int          topOff=15;
extern int          labelsize=9;
//extern color      labelcolor =LightBlue;
extern int          valuesize=9;
//extern color        valueColor2=LightBlue;
extern int          Digilablesize=7; //Digital Label size

//---- spread monitor
int Spread;

double Dssvalue;
double DssvalueM1;
double DssvalueM5;
double DssvalueM15;
double DssvalueM30;
double DssvalueH1;
double DssvalueH4;
double DssvalueD1;

double CCIvalue;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

string up;
string down;
string even;
double PriceColor;
double CCIColor;
double DSSColor;

double R3value;
double R2value;
double R1value;
double PPvalue;
double S1value;
double S2value;
double S3value;
double R3mid;
double R2mid;
double R1mid;
double PPmid;
double S1mid;
double S2mid;
double PricedigiColorM1;
double PricedigiColorM5;
double PricedigiColorM15;
double PricedigiColorM30;
double PricedigiColorH1;
double PricedigiColorH4;
double PricedigiColorD1;
double DssdigiColorM1;
double DssdigiColorM5;
double DssdigiColorM15;
double DssdigiColorM30;
double DssdigiColorH1;
double DssdigiColorH4;
double DssdigiColorD1;
double CcidigiColorM1;
double CcidigiColorM5;
double CcidigiColorM15;
double CcidigiColorM30;
double CcidigiColorH1;
double CcidigiColorH4;
double CcidigiColorD1;
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---- Defining the vars
//      
        Spread=NormalizeDouble((Ask-Bid)/Point,0);
        Dssvalue = iCustom(NULL,0,"Husky_DSS_Bressert",8,0,0);
        DssvalueM1 = iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,0);
        DssvalueM5 = iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,0);
        DssvalueM15 = iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,0);
        DssvalueM30 = iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,0);
        DssvalueH1 = iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,0);
        DssvalueH4 = iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,0);
        DssvalueD1 = iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,0);
        
        
        CCIvalue =  iCCI(NULL,0,14,0,0);
        R3value = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,0,0);
        R2value = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,1,0);
        R1value = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,2,0);
        PPvalue = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,3,0);
        S1value = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,4,0);
        S2value = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,5,0);
        S3value = iCustom(NULL, 0, "Husky_Pivot_Shifted", 0,6,0);
        R3mid = (R3value+R2value)/2;
        R2mid = (R2value+R1value)/2;
        R1mid = (R1value+PPvalue)/2;
        PPmid = (PPvalue+S1value)/2;
        S1mid = (S1value+S2value)/2;
        S2mid = (S2value+S3value)/2;
        
        
        
        
//-------Setting DSS Color      
        
       if ( iCustom(NULL,0,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,NULL,"Husky_DSS_Bressert",8,0,1) ) DSSColor = Lime;
       if ( iCustom(NULL,0,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,NULL,"Husky_DSS_Bressert",8,0,1) ) DSSColor= Red;
       if ( iCustom(NULL,0,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,NULL,"Husky_DSS_Bressert",8,0,1) ) DSSColor= LightBlue;
       
   //-- setting price digi colors     
       if ( iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM1 = Lime;
       if ( iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM1= Red;
       if ( iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_M1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM1= LightBlue;
       
       if ( iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM5 = Lime;
       if ( iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM5= Red;
       if ( iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_M5,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM5= LightBlue;
       if ( iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM15 = Lime;
       if ( iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM15= Red;
       if ( iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_M15,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM15= LightBlue;

       if ( iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM30 = Lime;
       if ( iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM30= Red;
       if ( iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_M30,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorM30= LightBlue;

       if ( iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorH1 = Lime;
       if ( iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorH1= Red;
       if ( iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_H1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorH1= LightBlue;

       if ( iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorH4 = Lime;
       if ( iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorH4= Red;
       if ( iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_H4,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorH4= LightBlue;

       if ( iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,0)> iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorD1 = Lime;
       if ( iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,0)< iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorD1= Red;
       if ( iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,0)== iCustom(NULL,PERIOD_D1,"Husky_DSS_Bressert",8,0,1) ) DssdigiColorD1= LightBlue;
//-------Setting Price Color            
        
       if ( iClose(NULL, NULL,0)>iOpen(NULL, NULL,0) ) PriceColor = Lime;
       if ( iClose(NULL, NULL,0)<iOpen(NULL, NULL,0) ) PriceColor= Red;
       if ( iClose(NULL, NULL,0)== iOpen(NULL, NULL,0) ) PriceColor= LightBlue;   
 
 //-- setting price digi colors
       if ( iClose(NULL, PERIOD_M1,0)>iOpen(NULL, PERIOD_M1,0) ) PricedigiColorM1 = Lime;
       if ( iClose(NULL, PERIOD_M1,0)<iOpen(NULL, PERIOD_M1,0) ) PricedigiColorM1= Red;
       if ( iClose(NULL, PERIOD_M1,0)== iOpen(NULL, PERIOD_M1,0) ) PricedigiColorM1= LightBlue;   
       
       if ( iClose(NULL, PERIOD_M5,0)>iOpen(NULL, PERIOD_M5,0) ) PricedigiColorM5 = Lime;
       if ( iClose(NULL, PERIOD_M5,0)<iOpen(NULL, PERIOD_M5,0) ) PricedigiColorM5= Red;
       if ( iClose(NULL, PERIOD_M5,0)== iOpen(NULL, PERIOD_M5,0) ) PricedigiColorM5= LightBlue;
       
       if ( iClose(NULL, PERIOD_M15,0)>iOpen(NULL, PERIOD_M15,0) ) PricedigiColorM15 = Lime;
       if ( iClose(NULL, PERIOD_M15,0)<iOpen(NULL, PERIOD_M15,0) ) PricedigiColorM15= Red;
       if ( iClose(NULL, PERIOD_M15,0)== iOpen(NULL, PERIOD_M15,0) ) PricedigiColorM15= LightBlue;      
 
       if ( iClose(NULL, PERIOD_M30,0)>iOpen(NULL, PERIOD_M30,0) ) PricedigiColorM30 = Lime;
       if ( iClose(NULL, PERIOD_M30,0)<iOpen(NULL, PERIOD_M30,0) ) PricedigiColorM30= Red;
       if ( iClose(NULL, PERIOD_M30,0)== iOpen(NULL, PERIOD_M30,0) ) PricedigiColorM30= LightBlue;
 
       if ( iClose(NULL, PERIOD_H1,0)>iOpen(NULL, PERIOD_H1,0) ) PricedigiColorH1 = Lime;
       if ( iClose(NULL, PERIOD_H1,0)<iOpen(NULL, PERIOD_H1,0) ) PricedigiColorH1= Red;
       if ( iClose(NULL, PERIOD_H1,0)== iOpen(NULL, PERIOD_H1,0) ) PricedigiColorH1= LightBlue;
 
       if ( iClose(NULL, PERIOD_H4,0)>iOpen(NULL, PERIOD_H4,0) ) PricedigiColorH4 = Lime;
       if ( iClose(NULL, PERIOD_H4,0)<iOpen(NULL, PERIOD_H4,0) ) PricedigiColorH4= Red;
       if ( iClose(NULL, PERIOD_H4,0)== iOpen(NULL, PERIOD_H4,0) ) PricedigiColorH4= LightBlue;

       if ( iClose(NULL, PERIOD_D1,0)>iOpen(NULL, PERIOD_D1,0) ) PricedigiColorD1 = Lime;
       if ( iClose(NULL, PERIOD_D1,0)<iOpen(NULL, PERIOD_D1,0) ) PricedigiColorD1= Red;
       if ( iClose(NULL, PERIOD_D1,0)== iOpen(NULL, PERIOD_D1,0) ) PricedigiColorD1= LightBlue;
 
 
 //-------Setting CCI Color            
        
       if ( iCCI(NULL,0,14,0,0)>iCCI(NULL,0,14,0,1)) CCIColor = Lime;
       if ( iCCI(NULL,0,14,0,0)<iCCI(NULL,0,14,0,1)) CCIColor= Red;
       if ( iCCI(NULL,0,14,0,0)==iCCI(NULL,0,14,0,1))CCIColor= LightBlue;
       // Setting CCI Digi color
       if ( iCCI(NULL,PERIOD_M1,14,0,0)>iCCI(NULL,PERIOD_M1,14,0,1)) CcidigiColorM1 = Lime;
       if ( iCCI(NULL,PERIOD_M1,14,0,0)<iCCI(NULL,PERIOD_M1,14,0,1)) CcidigiColorM1= Red;
       if ( iCCI(NULL,PERIOD_M1,14,0,0)==iCCI(NULL,PERIOD_M1,14,0,1))CcidigiColorM1= LightBlue;
       
       if ( iCCI(NULL,PERIOD_M5,14,0,0)>iCCI(NULL,PERIOD_M5,14,0,1)) CcidigiColorM5 = Lime;
       if ( iCCI(NULL,PERIOD_M5,14,0,0)<iCCI(NULL,PERIOD_M5,14,0,1)) CcidigiColorM5= Red;
       if ( iCCI(NULL,PERIOD_M5,14,0,0)==iCCI(NULL,PERIOD_M5,14,0,1))CcidigiColorM5= LightBlue;   
       
       if ( iCCI(NULL,PERIOD_M15,14,0,0)>iCCI(NULL,PERIOD_M15,14,0,1)) CcidigiColorM15 = Lime;
       if ( iCCI(NULL,PERIOD_M15,14,0,0)<iCCI(NULL,PERIOD_M15,14,0,1)) CcidigiColorM15= Red;
       if ( iCCI(NULL,PERIOD_M15,14,0,0)==iCCI(NULL,PERIOD_M15,14,0,1))CcidigiColorM15= LightBlue; 
                    
       if ( iCCI(NULL,PERIOD_M30,14,0,0)>iCCI(NULL,PERIOD_M30,14,0,1)) CcidigiColorM30 = Lime;
       if ( iCCI(NULL,PERIOD_M30,14,0,0)<iCCI(NULL,PERIOD_M30,14,0,1)) CcidigiColorM30= Red;
       if ( iCCI(NULL,PERIOD_M30,14,0,0)==iCCI(NULL,PERIOD_M30,14,0,1))CcidigiColorM30= LightBlue;
       
       if ( iCCI(NULL,PERIOD_H1,14,0,0)>iCCI(NULL,PERIOD_H1,14,0,1)) CcidigiColorH1 = Lime;
       if ( iCCI(NULL,PERIOD_H1,14,0,0)<iCCI(NULL,PERIOD_H1,14,0,1)) CcidigiColorH1= Red;
       if ( iCCI(NULL,PERIOD_H1,14,0,0)==iCCI(NULL,PERIOD_H1,14,0,1))CcidigiColorH1= LightBlue; 
       
       if ( iCCI(NULL,PERIOD_H4,14,0,0)>iCCI(NULL,PERIOD_H4,14,0,1)) CcidigiColorH4 = Lime;
       if ( iCCI(NULL,PERIOD_H4,14,0,0)<iCCI(NULL,PERIOD_H4,14,0,1)) CcidigiColorH4= Red;
       if ( iCCI(NULL,PERIOD_H4,14,0,0)==iCCI(NULL,PERIOD_H4,14,0,1))CcidigiColorH4= LightBlue;
       
       if ( iCCI(NULL,PERIOD_D1,14,0,0)>iCCI(NULL,PERIOD_D1,14,0,1)) CcidigiColorD1 = Lime;
       if ( iCCI(NULL,PERIOD_D1,14,0,0)<iCCI(NULL,PERIOD_D1,14,0,1)) CcidigiColorD1= Red;
       if ( iCCI(NULL,PERIOD_D1,14,0,0)==iCCI(NULL,PERIOD_D1,14,0,1))CcidigiColorD1= LightBlue;  
       
        
      
//---------Send Mail of price? 
//if (Minute()==00 )
///    SendMail(Symbol()+" is at "+DoubleToStr(Bid, Digits), Symbol()+" is at "+DoubleToStr(Bid, Digits));    
//if (Minute()==30 )
 //   SendMail(Symbol()+" is at "+DoubleToStr(Bid, Digits), Symbol()+" is at "+DoubleToStr(Bid, Digits));        
        
//---- Creating the text, color, font and object name
       //-- Current DSS, CCI, Price
       
       ObjectSetText("DSS Mon1","Dss:", labelsize, "Tahoma Narrow", DSSColor);
       ObjectSetText("DSS Mon2",DoubleToStr(Dssvalue , 2),valuesize, "Tahoma Narrow", DSSColor);
       ObjectSetText("Current Price1","Price:", labelsize, "Tahoma Narrow", PriceColor);
       ObjectSetText("Current Price2", DoubleToStr(Bid, Digits),valuesize, "Tahoma Narrow", PriceColor);
       ObjectSetText("CCI Mon1","Cci:", labelsize, "Tahoma Narrow", CCIColor);
       ObjectSetText("CCI Mon2",DoubleToStr(CCIvalue , 2),valuesize, "Tahoma Narrow", CCIColor);
       
       
       //- Pivots
       
       ObjectSetText("R3 Mon1","R3", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("R3 Mon2",DoubleToStr(R3value , Digits),valuesize, "Tahoma Narrow", indicator_color2);
       ObjectSetText("R2 Mon1","R2", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("R2 Mon2",DoubleToStr(R2value , Digits),valuesize, "Tahoma Narrow", indicator_color2);
       ObjectSetText("R1 Mon1","R1", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("R1 Mon2",DoubleToStr(R1value , Digits),valuesize, "Tahoma Narrow", indicator_color2);
       ObjectSetText("PP Mon1","PP", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("PP Mon2",DoubleToStr(PPvalue , Digits),valuesize, "Tahoma Narrow", indicator_color2);
       ObjectSetText("S1 Mon1","S1", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("S1 Mon2",DoubleToStr(S1value , Digits),valuesize, "Tahoma Narrow", indicator_color2);
       ObjectSetText("S2 Mon1","S2", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("S2 Mon2",DoubleToStr(S2value , Digits),valuesize, "Tahoma Narrow", indicator_color2);  
       ObjectSetText("S3 Mon1","S3", labelsize, "Tahoma Narrow", indicator_color1 );
       ObjectSetText("S3 Mon2",DoubleToStr(S3value , Digits),valuesize, "Tahoma Narrow", indicator_color2);
       ObjectSetText("R3 mid",DoubleToStr(R3mid , Digits),valuesize, "Tahoma Narrow", Yellow);
       ObjectSetText("R2 mid",DoubleToStr(R2mid , Digits),valuesize, "Tahoma Narrow", Yellow);
       ObjectSetText("R1 mid",DoubleToStr(R1mid , Digits),valuesize, "Tahoma Narrow", Yellow);
       ObjectSetText("PP mid",DoubleToStr(PPmid , Digits),valuesize, "Tahoma Narrow", Yellow);
       ObjectSetText("S1 mid",DoubleToStr(S1mid , Digits),valuesize, "Tahoma Narrow", Yellow);       
       ObjectSetText("S2 mid",DoubleToStr(S2mid , Digits),valuesize, "Tahoma Narrow", Yellow);
       
       //---Digital time labels
       ObjectSetText("M1 Label","M1", Digilablesize, "Tahoma Narrow", indicator_color1);
       ObjectSetText("M5 Label","M5", Digilablesize, "Tahoma Narrow", indicator_color1);
       ObjectSetText("M15 Label","M15", Digilablesize, "Tahoma Narrow", indicator_color1);
       ObjectSetText("M30 Label","M30", Digilablesize, "Tahoma Narrow", indicator_color1);
       ObjectSetText("H1 Label","H1", Digilablesize, "Tahoma Narrow", indicator_color1);
       ObjectSetText("H4 Label","H4", Digilablesize, "Tahoma Narrow", indicator_color1);
       ObjectSetText("D1 Label","D1", Digilablesize, "Tahoma Narrow", indicator_color1);
       
       //---Price digi
       ObjectSetText("PriceDigiM1","", Digilablesize+15, "Tahoma Narrow", PricedigiColorM1);
       ObjectSetText("PriceDigiM5","", Digilablesize+15, "Tahoma Narrow", PricedigiColorM5);
       ObjectSetText("PriceDigiM15","", Digilablesize+15, "Tahoma Narrow", PricedigiColorM15);
       ObjectSetText("PriceDigiM30","", Digilablesize+15, "Tahoma Narrow", PricedigiColorM30);
       ObjectSetText("PriceDigiH1","", Digilablesize+15, "Tahoma Narrow", PricedigiColorH1);
       ObjectSetText("PriceDigiH4","", Digilablesize+15, "Tahoma Narrow", PricedigiColorH4);
       ObjectSetText("PriceDigiD1","", Digilablesize+15, "Tahoma Narrow", PricedigiColorD1);
             
       //-- DSS Digit
       
       ObjectSetText("DssDigiM1",DoubleToStr(DssvalueM1 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorM1);
       ObjectSetText("DssDigiM5",DoubleToStr(DssvalueM5 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorM5);
       ObjectSetText("DssDigiM15",DoubleToStr(DssvalueM15 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorM15);
       ObjectSetText("DssDigiM30",DoubleToStr(DssvalueM30 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorM30);
       ObjectSetText("DssDigiH1",DoubleToStr(DssvalueH1 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorH1);
       ObjectSetText("DssDigiH4",DoubleToStr(DssvalueH4 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorH4);
       ObjectSetText("DssDigiD1",DoubleToStr(DssvalueD1 , 0), Digilablesize+1, "Tahoma Narrow", DssdigiColorD1);
       
       //-- Cci Digit
       
       ObjectSetText("CciDigiM1","", Digilablesize+15, "Tahoma Narrow", CcidigiColorM1);
       ObjectSetText("CciDigiM5","", Digilablesize+15, "Tahoma Narrow", CcidigiColorM5);
       ObjectSetText("CciDigiM15","", Digilablesize+15, "Tahoma Narrow", CcidigiColorM15);
       ObjectSetText("CciDigiM30","", Digilablesize+15, "Tahoma Narrow", CcidigiColorM30);
       ObjectSetText("CciDigiH1","", Digilablesize+15, "Tahoma Narrow", CcidigiColorH1);
       ObjectSetText("CciDigiH4","", Digilablesize+15, "Tahoma Narrow", CcidigiColorH4);
       ObjectSetText("CciDigiD1","", Digilablesize+15, "Tahoma Narrow", CcidigiColorD1);
  return(0);
  }






int ObjectMakeLabel( string n, int xoff, int yoff ) {
   ObjectCreate( n, OBJ_LABEL,WindowOnDropped(), 0, 0 );
   ObjectSet( n, OBJPROP_CORNER, corner );
   ObjectSet( n, OBJPROP_XDISTANCE, xoff );
   ObjectSet( n, OBJPROP_YDISTANCE, yoff );
   ObjectSet( n, OBJPROP_BACK, true );
}

int init()
  {

//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   int top=topOff;
   int left = 0;
   int leftdigi = 90;
   int leftpivot = 300; 
  //-- 
   ObjectMakeLabel( "Current Price1", left, top+15);   
   ObjectMakeLabel( "Current Price2", left+35, top+15 );
   ObjectMakeLabel( "DSS Mon1", left, top+30);   
   ObjectMakeLabel( "DSS Mon2", left+35, top+30);
   ObjectMakeLabel( "CCI Mon1", left, top+45);   
   ObjectMakeLabel( "CCI Mon2", left+30, top+45); 
  //---Digital Indicator Label
  ObjectMakeLabel( "M1 Label", leftdigi, top);
  ObjectMakeLabel( "M5 Label", leftdigi+23, top);
  ObjectMakeLabel( "M15 Label", leftdigi+46, top);
  ObjectMakeLabel( "M30 Label", leftdigi+69, top);
  ObjectMakeLabel( "H1 Label", leftdigi+92, top);
  ObjectMakeLabel( "H4 Label", leftdigi+115, top);
  ObjectMakeLabel( "D1 Label", leftdigi+138, top);
  //--- Price Digi
  ObjectMakeLabel( "PriceDigiM1", leftdigi, top+5);
  ObjectMakeLabel( "PriceDigiM5", leftdigi+23, top+5);
  ObjectMakeLabel( "PriceDigiM15", leftdigi+46, top+5);
  ObjectMakeLabel( "PriceDigiM30", leftdigi+69, top+5);
  ObjectMakeLabel( "PriceDigiH1", leftdigi+92, top+5);
  ObjectMakeLabel( "PriceDigiH4", leftdigi+115, top+5);
  ObjectMakeLabel( "PriceDigiD1", leftdigi+138, top+5);
 
  //-- DSS DIGI
   ObjectMakeLabel( "DssDigiM1", leftdigi, top+30);
  ObjectMakeLabel( "DssDigiM5", leftdigi+23, top+30);
  ObjectMakeLabel( "DssDigiM15", leftdigi+46, top+30);
  ObjectMakeLabel( "DssDigiM30", leftdigi+69, top+30);
  ObjectMakeLabel( "DssDigiH1", leftdigi+92, top+30);
  ObjectMakeLabel( "DssDigiH4", leftdigi+115, top+30);
  ObjectMakeLabel( "DssDigiD1", leftdigi+138, top+30);
 
  
  //---Cci Digit
  ObjectMakeLabel( "CciDigiM1", leftdigi, top+35);
  ObjectMakeLabel( "CciDigiM5", leftdigi+23, top+35);
  ObjectMakeLabel( "CciDigiM15", leftdigi+46, top+35);
  ObjectMakeLabel( "CciDigiM30", leftdigi+69, top+35);
  ObjectMakeLabel( "CciDigiH1", leftdigi+92, top+35);
  ObjectMakeLabel( "CciDigiH4", leftdigi+115, top+35);
  ObjectMakeLabel( "CciDigiD1", leftdigi+138, top+35);
  
  
  //--Pivots
   ObjectMakeLabel( "R3 Mon1",leftpivot, top);   
   ObjectMakeLabel( "R3 Mon2",leftpivot, top+15); 
   ObjectMakeLabel( "R3 Mid", leftpivot+25, top+30); 
   ObjectMakeLabel( "R2 Mon1",leftpivot+50, top);   
   ObjectMakeLabel( "R2 Mon2",leftpivot+50, top+15); 
   ObjectMakeLabel( "R2 Mid", leftpivot+75, top+30); 
   ObjectMakeLabel( "R1 Mon1",leftpivot+100, top);   
   ObjectMakeLabel( "R1 Mon2",leftpivot+100, top+15); 
   ObjectMakeLabel( "R1 Mid", leftpivot+125, top+30); 
   ObjectMakeLabel( "PP Mon1",leftpivot+150, top);   
   ObjectMakeLabel( "PP Mon2",leftpivot+150, top+15); 
   ObjectMakeLabel( "PP Mid", leftpivot+175, top+30); 
   ObjectMakeLabel( "S1 Mon1",leftpivot+200, top);   
   ObjectMakeLabel( "S1 Mon2",leftpivot+200, top+15); 
   ObjectMakeLabel( "S1 Mid", leftpivot+225, top+30); 
   ObjectMakeLabel( "S2 Mon1",leftpivot+250, top);   
   ObjectMakeLabel( "S2 Mon2",leftpivot+250, top+15); 
   ObjectMakeLabel( "S2 Mid", leftpivot+275, top+30); 
   ObjectMakeLabel( "S3 Mon1",leftpivot+300, top);   
   ObjectMakeLabel( "S3 Mon2",leftpivot+300, top+15); 





}


  


//----
   return(0);
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

   ObjectDelete( "DSS Mon1" );   
   ObjectDelete( "DSS Mon2" ); 
   ObjectDelete( "Current Price1" );    
   ObjectDelete( "Current Price2" );
   ObjectDelete( "CCI Mon1" );    
   ObjectDelete( "CCI Mon2" );    
   ObjectDelete( "R3 Mon1" );    
   ObjectDelete( "R3 Mon2" );
   ObjectDelete( "R2 Mon1" );    
   ObjectDelete( "R2 Mon2" );  
   ObjectDelete( "R1 Mon1" );    
   ObjectDelete( "R1 Mon2" );  
   ObjectDelete( "PP Mon1" );    
   ObjectDelete( "PP Mon2" );  
   ObjectDelete( "S3 Mon1" );    
   ObjectDelete( "S3 Mon2" );  
   ObjectDelete( "S2 Mon1" );    
   ObjectDelete( "S2 Mon2" );  
   ObjectDelete( "S1 Mon1" );    
   ObjectDelete( "S1 Mon2" );
   ObjectDelete( "R3 Mid" );
   ObjectDelete( "R2 Mid" );
   ObjectDelete( "R1 Mid" );
   ObjectDelete( "PP Mid" );
   ObjectDelete( "S1 Mid" );
   ObjectDelete( "S2 Mid" );
   ObjectDelete( "M1 Label");
   ObjectDelete( "M5 Label");
   ObjectDelete( "M15 Label");
   ObjectDelete( "M30 Label");
   ObjectDelete( "H1 Label");
   ObjectDelete( "H4 Label");
   ObjectDelete( "D1 Label");
   ObjectDelete( "PriceDigiM1");
   ObjectDelete( "PriceDigiM5");
   ObjectDelete( "PriceDigiM15");
   ObjectDelete( "PriceDigiM30");
   ObjectDelete( "PriceDigiH1");
   ObjectDelete( "PriceDigiH4");
   ObjectDelete( "PriceDigiD1");
   ObjectDelete( "DssDigiM1");
   ObjectDelete( "DssDigiM5");
   ObjectDelete( "DssDigiM15");
   ObjectDelete( "DssDigiM30");
   ObjectDelete( "DssDigiH1");
   ObjectDelete( "DssDigiH4");
   ObjectDelete( "DssDigiD1"); 
   ObjectDelete( "CciDigiM1");
   ObjectDelete( "CciDigiM5");
   ObjectDelete( "CciDigiM15");
   ObjectDelete( "CciDigiM30");
   ObjectDelete( "CciDigiH1");
   ObjectDelete( "CciDigiH4");
   ObjectDelete( "CciDigiD1"); 
   

//----
   return(0);
  }
  

  


