//+------------------------------------------------------------------+
//|                                                   Range Data.mq4 |
//|                      Copyright  004, MetaQuotes Software Corp.  |
//|                                        http://www.metaquotes.net |
//|                              Created 17/12/08 David Applin       |
//|  Modified to cater for 5 decimal prices from Alpari 04/04/09     |
//|                                               David Applin       |
//+------------------------------------------------------------------+
#property copyright "Copyright  004, MetaQuotes Software Corp."
#property link      "http://www.coronado-enterprises.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 CLR_NONE

double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;
double P=0;
double Q=0;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(4);
  SetIndexStyle(0,DRAW_ARROW);
  SetIndexArrow(0,159);
  SetIndexBuffer(0, ExtMapBuffer1);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- TODO: add your code here

   //---- Skip unless
   if(Period() < 1441)    // chart period is 24 hours or less...
      {

      //---- Get new daily prices

      ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);

      yesterday_close = rates_d1[1][4];
      yesterday_open = rates_d1[1][1];
      today_open = rates_d1[0][1];
      yesterday_high = rates_d1[1][3];
      yesterday_low = rates_d1[1][2];
      day_high = rates_d1[0][3];
      day_low = rates_d1[0][2];

      //---- Calculate Ranges

      D = (day_high - day_low);
      Q = (yesterday_high - yesterday_low);

      // From IGP
      if (Q > 5)  nQ = Q;
      else  nQ = MathRound(Q*MathPow(10.0, Digits-1));  //"Digits" may be 2, 4 or 5.
      if (D > 5)  nD = D;
      else  nD = MathRound(D*MathPow(10.0, Digits-1));


      double seco= (Time[4]-Time[5])-MathMod(CurTime(),Time[4]-Time[5]);
      double minu=seco/60;
      seco=(minu-MathFloor(minu))*60;
      minu=MathFloor(minu);
  
      Comment("    Previous Days Range = ",nQ,"\n    Current Days Range   = ",nD,"\n    Time for next bar:    ",	minu," min ",seco," sec");
      }
//---- End Of Program
   return(0);

  }
//+------------------------------------------------------------------+